<?php
header('Content-Type: text/html; charset=utf-8');

$curmode=0;
$MaxL=0;
$q='';
$path='';
$size=0;
$prevmode='';
$Mode='';

function getwords($s) {
    global $curmode,$q,$Mode;

    $wmode = -1;
    $ss = 0; 
    $p = 0;

    while ($ss < strlen($s)) {
        $buf = '';
        $begword = $endword = 0;
        while ($ss < strlen($s)) {
            if (strncmp(substr($s,$ss),"<i>",3) == 0)
                $curmode|=1;
            else if (strncmp(substr($s,$ss),"</i>",4) == 0)
                $curmode&=~1;
            else if (strncmp(substr($s,$ss),"<dt>",4) == 0)
                $curmode|=2;
            else if (strncmp(substr($s,$ss),"</dt>",5) == 0)
                $curmode&=~2;
            else if (strncmp(substr($s,$ss),"<small>",7) == 0)
                $curmode|=4;
            else if (strncmp(substr($s,$ss),"</small>",8) == 0)
                $curmode&=~4;

            if (strncmp(substr($s,$ss),"<span class=\"rad\">",18) == 0) {
                if ($wmode==-1) {
                    $wmode = $curmode;
                    $begword = $ss;
                }
                $ss += 18;
                $endword = $ss;
            }
            else if (strncmp(substr($s,$ss),"<span ",6) == 0 || strncmp(substr($s,$ss),"</span>",7) == 0) {
                while ($ss < strlen($s) && substr($s,$ss,1) != '>')
                    $ss++;
                    if (substr($s,$ss,1) == '>')
                        $ss++;
                    if ($wmode == -1) {
                        $wmode = $curmode;
                        $begword = $ss;
                    }
                    $endword = $ss;
            }
            else if (substr($s,$ss,1) == '<' && strncmp(substr($s,$ss),"<em>",4) && strncmp(substr($s,$ss),"</em>",5)) {
                while ($ss < strlen($s) && substr($s,$ss,1) != '>')
                    $ss++;
                if (substr($s,$ss,1)=='>') 
                    $ss++;
                break;
            }
            else if (substr($s,$ss,1) == ' ' || substr($s,$ss,1) == '\n' ||
                    substr($s,$ss,1) == '.' || substr($s,$ss,1) == ',' || 
                    substr($s,$ss,1) == ';' || substr($s,$ss,1) == ':' ||
                    substr($s,$ss,1) == '=' || substr($s,$ss,1)=='!' || 
                    substr($s,$ss,1) == '?') {
                $ss++;
                break;
            }
            else if (substr($s,$ss,1) == '&') {
                if ($wmode == -1) {
                    $wmode = $curmode;
                    $begword = $ss;
                }
            while ($ss < strlen($s) && substr($s,$ss,1) != ';')
                $buf .= substr($s,$ss++,1);
                $buf .= substr($s,$ss++,1);
                $endword = $ss;
            }
            else {
                if ($wmode == -1) {
                    $wmode = $curmode;
                    $begword = $ss;
                }
                $buf .= substr($s,$ss++,1);
                $endword = $ss;
            }
        }
        $buf=uni_decode($buf);

        $buf = str_replace("<em>", "",$buf);
        $buf = str_replace("</em>", "",$buf);
        $buf = str_replace("&#8211;", "",$buf);
        $buf = str_replace("&#183;", "",$buf);
        $buf = str_replace("&#769;", "",$buf);

        $buf = str_replace('·','',$buf);
        $acute = mb_convert_encoding('&#769;', "UTF-8", "HTML-ENTITIES");
        $buf = str_replace("$acute",'',$buf);

        $buf = str_replace("*", "",$buf);
        $buf = str_replace("-", "",$buf);
        $buf = str_replace("=", "",$buf);
        $buf = str_replace("&mdash;", "",$buf);
        $buf = str_replace("&ndash;", "",$buf);
        $buf = str_replace("&laquo;", "",$buf);
        $buf = str_replace("&raquo;", "",$buf);
        $buf = str_replace("&gt;", "",$buf);
        $buf = str_replace("&lt;", "",$buf);
        $buf = str_replace("<span class=\"rad\">", "",$buf);
        $buf = str_replace("</span>", "",$buf);
        $buf = str_replace("\"", "",$buf);
        $buf = str_replace("\'", "",$buf);
        $buf = str_replace("/", "",$buf);
        $buf = str_replace("ё","е",$buf);

        //neparaj krampoj
        if (strchr($buf,'(') && !strchr($buf,')')) {
            if (substr($buf,0,1) == '(')
                $begword++;
            $buf = str_replace("(","",$buf); //
        }
        if (strchr($buf,')') && !strchr($buf,'(')) {
            if (substr($buf,-1) == ')')
                $endword--;
            $buf = str_replace(")","",$buf); //
        }
        if ($buf && substr($buf,0,1) == '(' && substr($buf,-1) == ')') {
            $buf = substr($buf,1,-1);
            $begword++; 
            $endword--;
        }

        //kadrantaj citiloj
        if (strncmp(substr($s,$begword),"&laquo;",7) == 0)
            $begword += 7;
        if (strncmp(substr($s,$endword-7),"&raquo;",7) == 0)
            $endword -= 7;

        $buf = mb_convert_case($buf,MB_CASE_LOWER,'utf-8');
        //echo "[$buf]";
        if ($buf<>'') {
            $ok=true;
            if (strchr($Mode,'k') && ($wmode&1));
            else if (strchr($Mode,'v') && ($wmode&2));
            else if (strchr($Mode,'e') && ($wmode&4));
            else if (strchr($Mode,'t') && ($wmode == 0));
            else $ok = false;
            if ($ok and wcmp($q,$buf)) {
                $s = substr($s,0,$endword)."</span>".substr($s,$endword);
                $s = substr($s,0,$begword)."<span class=\"found\">".substr($s,$begword);
                $ss += strlen("<span class=\"found\">")+strlen("</span>");
            }
        } //if
    }
    return $s;
} //getwords

function uni_decode ($s) {
    $s = str_replace("&#264;","Cx",$s);
    $s = str_replace("&#265;","cx",$s);
    $s = str_replace("&#284;","Gx",$s);
    $s = str_replace("&#285;","gx",$s);
    $s = str_replace("&#292;","Hx",$s);
    $s = str_replace("&#293;","hx",$s);
    $s = str_replace("&#308;","Jx",$s);
    $s = str_replace("&#309;","jx",$s);
    $s = str_replace("&#348;","Sx",$s);
    $s = str_replace("&#349;","sx",$s);
    $s = str_replace("&#364;","Ux",$s);
    $s = str_replace("&#365;","ux",$s);
    return $s;
} //uni_decode

function ReadWordLn($f) {
    $buf = ''; 
    $c = '';
    while (!feof($f)) {
        $c = fread($f,1);
        if ($c === false || $c == '' || $c == ' ' || $c == "\n" || $c == "\r") break;
        $buf .= $c;
    }
    if ($c != "\n") 
        fgets($f);
    return $buf;
} //ReadWordLn

function ReadWord($f) {
    $buf = ''; 
    $c = '';
    while (!feof($f)) {
        $c = fread($f,1);
        if ($c === false || $c == '' || $c == ' ' || $c == "\n" || $c == "\r") break;
        $buf .= $c;
    }
    return $buf;
} //ReadWord

function ReadHTMLWord($f) {
    $buf = '';
    while (!feof($f)) {
        $c = fread($f,1);
        if ($c == '' || $c === false) break;
        if ($c == '<') {
            $buf .= $c;
            while (!feof($f) && $c != '>') {
                $c = fread($f,1);
                if ($c === false || $c == '') break;
                $buf .= $c;
            }
            if (strncmp($buf,"<a ",3) == 0) break;
            if (strncmp($buf,"</a",3) == 0) break;
            if (strncmp($buf,"<dl",3) == 0) break;
            if (strncmp($buf,"</dl",3) == 0) break;
        }
        else if ($c == ' ' || $c == "\n") {
            $buf .= $c;
            break;
        }
        else if ($c === false || $c == '')
            break;
        else
            $buf .= $c;
    }
    return $buf;
} //ReadHTMLWord

function look($f, $key) {
    global $size;

    $min = 0;
    $max = $size;

    if ($size == 0) return -1;
    $mid = $size;

    while ($max - $min > 1) {
        $mid = (int)(($max + $min) / 2);
        if ($mid > $size) return -1;
        fseek($f,$mid,SEEK_SET);
        if ($mid)
            fgets($f); //probably a partial line
        $w = ReadWordLn($f);

        if (strcmp($w,$key) < 0)
            $min = $mid;
        else
            $max = $mid;
    }
    if ($min > $size) return -1;
    fseek($f,$min,SEEK_SET);
    if ($min)
        fgets($f);  //probably a partial line

    for (;;) {
        $min = ftell($f);
        $w = ReadWordLn($f);
        if (strcmp($w,$key) >= 0) break;
    }
    fseek($f,$min,SEEK_SET);
    return $min;
}

function load($name, $pos) {
    global $path,$MaxL,$q;
    
    $fname = $path . $name . '.html';
    $f = fopen($fname,"r");
    if ($f === false) return;
    fseek($f,$pos,SEEK_SET);
    
    while (!feof($f)) {
        $buf = ReadHTMLWord($f);
        if (strlen($buf) > $MaxL) 
            $MaxL = strlen($buf);
    
        $buf = getwords($buf);
        echo $buf;
    
        if (strstr($buf,"</dl>")) break;
    }
    
    fclose($f);
} //load


$result = [];
$coll2 = [];

function fragments($s) {
    global $Mode,$prevmode,$coll2;
    
    $ss = substr($s,1);
    if (isset($coll2[$ss])) return;
    
    $mode = substr($s,0,1);
    $name = ''; 
    $spos = '';
    for ($i = 1; $i < strlen($s); $i++) {
        if (strstr('0123456789',substr($s,$i,1)))
            $spos .= substr($s,$i,1);
        else
            $name .= substr($s,$i,1);
    }
    $pos = (int)$spos;
    
    //echo "$mode $name [$pos]\n";
    
    switch ($mode) {
        case '1':
            if (!strchr($Mode,'v')) return;
            break;
        case '2':
            if (!strchr($Mode,'t')) return;
            break;
        case '3':
            if (!strchr($Mode,'k')) return;
            break;
        case '4':
            if (!strchr($Mode,'e')) return;
            break;
        case '5':
            if (!strchr($Mode,'k')) return;
            if (!strchr($Mode,'e')) return;
            break;
    }
    
    if ($prevmode && $prevmode != $mode)
        echo "\n<hr />\n";
    $prevmode = $mode;
    
    load($name,$pos);
    echo "\n<hr />\n";
    $coll2[$ss] = true;
}

function checkbrc($w) {
    $ww = 0;
    $w1 = $w2 = '';
    for (; $ww < strlen($w); $ww++) {
        if (substr($w,$ww,1) != '(' || substr($w,$ww+1,1) == '*') {
            $w1 .= substr($w,$ww,1);
            $w2 .= substr($w,$ww,1);
        }
        else
            for ($ww++; $ww < strlen($w) && substr($w,$ww,1) != ')'; $ww++)
                $w1 .= substr($w,$ww,1);
        if ($ww >= strlen($w)) break;
    }
    $ok = (strlen($w1) == strlen($w2));
    return [$ok,$w1,$w2];
} //checkbrc

// Komparu vorton kun sxablono
function wcmp($pat, $word) {
    list($brc,$w1,$w2) = checkbrc($word);
    if ($brc)
        return wcmp0($pat,$word);
    else
        return wcmp0($pat,$w1)||wcmp0($pat,$w2);
} //wcmp

function wcmp0 ($pat, $word) {
    $p = 0; 
    $w = 0;
    for (;;) {
      if (substr($pat,$p,1) == '*') {  //jxokero
        if (substr($word,$w,1) == 'x') return false;     //x-oj estas kromsignoj!
        if ($p+1>=strlen($pat)) return true;     //fino de sxablono
        for (; $w<strlen($word); $w++)
          if (wcmp0(substr($pat,$p+1),substr($word,$w))) return true;
          return false;
      }
      else if (substr($pat,$p,1) != substr($word,$w,1))
        return false;
      $p++;
      $w++;
      if ($p >= strlen($pat)) break;
    }
    
    if (substr($pat,$p,1) == substr($word,$w,1)) 
        return true;
    else 
        return false;
} //wcmp0

function prolog($base) {
    echo
        "<!DOCTYPE>\n" .
        "<html>\n" .
        "<head>\n" .
        "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n" .
        "<base href=\"$base\" />\n" .
        "<link rel=\"stylesheet\" type=\"text/css\" href=\"vortaro.css\" />\n" .
        "<title>Результаты поиска</title>\n" .
        "</head>\n" .
        "<body>\n" .
        "<div>\n";
} //prolog

function epilog() {
    echo
        "<hr size=\"6\" />\n" .
        "</div>\n" .
        "</body>\n" .
        "</html>\n";
} //epilog


function doCGI($request, $base) {
    global $path,$size,$result,$q;
    
    if ($request == '') return;
    
    $q = $request;//
    
    prolog($base);
    
    if ($q == "*") {
      epilog();
      return;
    }
          
    $q0 = $q;
    $n = strpos($q0,'*');
    if ($n !== false)
      $q0 = substr($q0,0,$n);
    
    $fname = $path."index.ind";
    $size = filesize($fname);
    $f = fopen($fname,"rb");
    if ($f === false) return;
    
    $n = look($f,$q0);
    
    if ($n == -1) return;
    
    while (!feof($f)) {
        $s = ReadWord($f);
        if (strncmp($s,$q0,strlen($q0))) break;
        if (!wcmp0($q,$s)) {
            fgets($f);
            continue;
        }
      
        foreach(explode(' ',fgets($f)) as $b) {
            $result[] = trim($b);
        }
    } //while
    
    sort($result);
    foreach ($result as $r) {
        fragments($r);
    }
    
    $result = array();
    $coll2 = array();
    epilog();
} //doCGI


$Mode='';
if (@$_REQUEST['p'] == 'on') $Mode .= 'p';
if (@$_REQUEST['v'] == 'on') $Mode .= 'v';
if (@$_REQUEST['t'] == 'on') $Mode .= 't';
if (@$_REQUEST['e'] == 'on') $Mode .= 'e';
if (@$_REQUEST['k'] == 'on') $Mode .= 'k';
$query = @$_REQUEST['s'];

if (!strchr($Mode,'p'))
    $query.="*";
$query = str_replace("**","*",$query);
$query = str_replace("-","",$query);
$query = mb_convert_case($query,MB_CASE_LOWER,'utf-8');
$query = str_replace("ё","е",$query);
$query = uni_decode($query);
$path = '';

//echo $query;
doCGI($query,'');
